unit Unit_Main;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls,
  LibUSB;

type
  TForm_Main = class(TForm)
    Memo_Dbg: TMemo;
    Btn_Connect: TButton;
    Btn_Send: TButton;
    procedure Btn_ConnectClick(Sender: TObject);
    procedure Btn_SendClick(Sender: TObject);
  private
    { Private declarations }
  public
    pUSBDev : pUSBDevHandle;
    //
    Procedure Dbg( const msg : String );
    //
    Function Usb_Connect( VID,PID : Word ): Boolean;
  end;

var
  Form_Main: TForm_Main;

implementation

{$R *.dfm}

Const
 cVID        = $0483;
 cPID        = $C1B0;
 cRead_Ep01  =   $81; // 0x81
 cWrite_EP01 =   $01; // 0x01;

Var
  Buf        : Packed Array[0..64-1] of Byte;


Procedure TForm_Main.Dbg( const msg : String );
 begin
  Memo_Dbg.Lines.Add( msg );
 end;

//
Function TForm_Main.Usb_Connect( VID,PID : Word ): Boolean;
var
  pDev : pUsbDevice;
  pBus : pUsbBus;
  Rst  : Integer;
begin
  pUsbDev := nil;

  usb_init();

  usb_find_busses();
  usb_find_devices();

  pBus := usb_get_busses();
  While Assigned(pBus) do
   begin
    pDev := pBus^.devices;
    while Assigned(pDev) do
     begin
      //
      Dbg('Device : VID:' + IntToHex(pDev^.descriptor.idVendor ,4) + ' ' +
                   'PID:' + IntToHex(pDev^.descriptor.idProduct,4) );
      //
      if (pDev^.descriptor.idVendor  = VID) and
         (pDev^.descriptor.idProduct = PID) then
       begin
        pUsbDev := usb_open(pDev);
        Result := True;
        break;
       end;
      //
      pDev := pDev^.next;
     end;
    pBus := pBus^.next;
   end;

  //
  Case pUsbDev <> nil of
   True  : begin

            usb_set_configuration(pUsbDev, 1);
            usb_claim_interface  (pUsbDev, 1);
            //usb_set_altinterface (pUsbDev, 0);

            Result := True;
           end;
   False : Result := False;
  end;
end;


//
procedure TForm_Main.Btn_ConnectClick(Sender: TObject);
 begin
  //
  Case USB_Connect( cVID,cPID ) of
   True  : Dbg('Connected');
   False : Dbg('Not Found');
  End;
 end;

procedure TForm_Main.Btn_SendClick(Sender: TObject);
 Var
  i   : Integer;
  Rst : Integer;
begin
 //for i := 0 to 1024 do
  begin
   //
   FillChar(Buf,SizeOf(Buf),$FF);
   Rst := USB_Bulk_Write(pUSBDev,cWrite_EP01,@Buf,SizeOf(Buf),100);
          Dbg('Write Rst:'+ IntToStr(Rst));
   //
   FillChar(Buf,SizeOf(Buf),$00);
   Rst := USB_Bulk_Read(pUSBDev,cRead_EP01,@Buf,SizeOf(Buf),100);
          Dbg('Read Rst:'+ IntToStr(Rst));
          Dbg(usb_strerror);
  end;        
end;

end.
